package com.autentia.training.spring.mail;

import java.io.IOException;
import java.util.Date;
import java.util.HashMap;
import java.util.Map;

import org.apache.velocity.app.VelocityEngine;
import org.apache.velocity.tools.generic.DateTool;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.core.io.Resource;
import org.springframework.ui.velocity.VelocityEngineUtils;

import com.autentia.training.spring.model.User;

public class VelocityEmailMessageProviderImpl implements EmailMessageProvider {

	private Map<String,Resource> inlineFiles;
	
	private String subject;
	
	private String body;
	
	private String template;
	
	@Autowired
	private VelocityEngine velocityEngine;
	
	public String getSubject(){
		return subject;
	}
	
	public void setSubject(String subject){
		this.subject = subject;
	}
	
	public String getBody() {
		return body;
	}
	
	public Map<String, Resource> getInlineFiles() {
		return inlineFiles;
	}
	
	public void setInlineFiles(Map<String, Resource> inlineFiles) {
		this.inlineFiles = inlineFiles;
	}

	public void setTemplate(String template){
		this.template = template;
	}
	
	public void fillblanks(String courseName, Date date, User user) throws IOException {
		Map<String,Object> model = new HashMap<String,Object>();
		model.put("date", new DateTool());
		model.put("user", user);
		model.put("courseDate", date);
		model.put("courseName", courseName);
		
		
		this.body = VelocityEngineUtils.mergeTemplateIntoString(
				velocityEngine, template, model);
		
	}
}